%{
/* 
	A lexer for the light koolness option of kooltalk.
*/

#undef yywrap /* Older versions of flex don't follow the POSIX standard */
%}
%s SMALLSSTATE SSTATE
%%
	/* The letter "s" needs some special treatment */
[sS][sS]					   {printf ("%s", yytext);}
s						      {BEGIN SMALLSSTATE;}
<SMALLSSTATE>[^a-zA-Z]	{
								  printf("z%s", yytext); 
								  BEGIN 0;
							   }
<SMALLSSTATE>[a-zA-Z]	{
								  printf("s"); 
								  BEGIN 0;
								  yyless(0); 
							   }
S						      {BEGIN SSTATE;}
<SSTATE>[^a-zA-Z]       {
                          printf("Z%s", yytext);
								  BEGIN 0;
								}
<SSTATE>[a-zA-Z] 	      { 
								  printf("S"); 
								  BEGIN 0;
								  yyless(0); 
								}
	/* Normal cases: Do common kool replacements */
[eE]						{printf ("3");}
[iI]						{printf ("1");}
[oO]						{printf ("0");}
f							{printf ("ph");}
F							{printf ("Ph");}
	/* Default */
.							ECHO;
%%
int yywrap() {
	/* 
	The flex library will not provide us with a working yywrap as we change
	the function names with sed. Here we just reproduce AT&T lex standard
	behaviour.
	*/
	return(1);
}

int light_koolness(char  filename[256])
{
if (strlen (filename) > 0)
    {
      yyin = fopen (filename, "r");
      if (yyin == NULL)
	{
	  fprintf (stderr, "Couldn't open %s\n", filename);
	  exit (1);
	} 
    }
  else
   yyin = stdin;
	yylex();
	return(0);
}
